/*******************************************************************************
 * JMMC project ( http://www.jmmc.fr ) - Copyright (C) CNRS.
 ******************************************************************************/

/**** MODULE   'amdlib' ****/
/****                 contains :                         ****/
/****    o DEFINE CONSTANTS                                ****/
/****    o ENUM CONSTANTS                                ****/
/****    o STRUCTURES                                    ****/
/****    o FUNCTIONS                                     ****/


if (!is_void(plug_in)) plug_in, "amdlib";
write,"amdlib plugin loaded";


/****** DEFINE CONSTANTS (numerical ones only) ******/

/* Wrapping of 'amdlibERROR_LENGTH' define */
amdlibERROR_LENGTH = int (256);
        
/* Wrapping of 'amdlibNB_TEL' define */
amdlibNB_TEL = int (3);
        
/* Wrapping of 'amdlibNBASELINE' define */
amdlibNBASELINE = int (3*(3-1)/2);
        
/* Wrapping of 'amdlibDET_SIZE_X' define */
amdlibDET_SIZE_X = int (512);
        
/* Wrapping of 'amdlibDET_SIZE_Y' define */
amdlibDET_SIZE_Y = int (512);
        
/* Wrapping of 'amdlibMAX_NB_ROWS' define */
amdlibMAX_NB_ROWS = int (3);
        
/* Wrapping of 'amdlibMAX_NB_COLS' define */
amdlibMAX_NB_COLS = int (5);
        
/* Wrapping of 'amdlibNB_PHOTO_CHANNELS' define */
amdlibNB_PHOTO_CHANNELS = int (3);
        
/* Wrapping of 'amdlibFIRST_FRAME' define */
amdlibFIRST_FRAME = int (1);
        
/* Wrapping of 'amdlibALL_FRAMES' define */
amdlibALL_FRAMES = int (-1);
        
/* Wrapping of 'amdlibBAD_PIXEL_FLAG' define */
amdlibBAD_PIXEL_FLAG = int (0);
        
/* Wrapping of 'amdlibGOOD_PIXEL_FLAG' define */
amdlibGOOD_PIXEL_FLAG = int (1);
        
/* Wrapping of 'amdlibNB_INS_CFG_KEYW' define */
amdlibNB_INS_CFG_KEYW = int (1024);
        
/* Wrapping of 'amdlibMAX_INS_CFG_COMMENTLEN' define */
amdlibMAX_INS_CFG_COMMENTLEN  = int (72*64);
        
/* Wrapping of 'amdlibKEYW_LINE_LEN' define */
amdlibKEYW_LINE_LEN = int (80);
        
/* Wrapping of 'amdlibKEYW_NAME_LEN' define */
amdlibKEYW_NAME_LEN = int (80);
        
/* Wrapping of 'amdlibKEYW_VAL_LEN' define */
amdlibKEYW_VAL_LEN = int (80);
        
/* Wrapping of 'amdlibKEYW_CMT_LEN' define */
amdlibKEYW_CMT_LEN = int (80);
        
/* Wrapping of 'amdlibMAX_NB_AXIS' define */
amdlibMAX_NB_AXIS = int (3);
        
/* Wrapping of 'amdlibNB_SPECTRAL_CHANNELS' define */
amdlibNB_SPECTRAL_CHANNELS = int (512);
        
/* Wrapping of 'amdlibNB_BANDS' define */
amdlibNB_BANDS = int (3);
        
/* Wrapping of 'amdlibPHOTO1_CHANNEL' define */
amdlibPHOTO1_CHANNEL = int (0);
        
/* Wrapping of 'amdlibPHOTO2_CHANNEL' define */
amdlibPHOTO2_CHANNEL = int (1);
        
/* Wrapping of 'amdlibPHOTO3_CHANNEL' define */
amdlibPHOTO3_CHANNEL = int (2);
        
/* Wrapping of 'amdlibINTERF_CHANNEL' define */
amdlibINTERF_CHANNEL = int (3);
        
/* Wrapping of 'amdlibMAX_NB_FRAMES_SC' define */
amdlibMAX_NB_FRAMES_SC = int (6);
        
/* Wrapping of 'amdlibMAX_NB_FRAMES_P2VM' define */
amdlibMAX_NB_FRAMES_P2VM = int (9);
        
/* Wrapping of 'amdlib_OI_REVISION' define */
amdlib_OI_REVISION = int (1);
        
/****** ENUM CONSTANTS ******/

/* Wrapping of 'amdlibBOOLEAN' enum */
amdlibFALSE = int (0);
amdlibTRUE = int (amdlibFALSE + 1);

/* Wrapping of 'amdlibCOMPL_STAT' enum */
amdlibFAILURE = int (1);
amdlibSUCCESS = int (amdlibFAILURE + 1);

/* Wrapping of 'amdlibTELS' enum */
amdlibTEL1 = int (0);
amdlibTEL2 = int (amdlibTEL1 + 1);
amdlibTEL3 = int (amdlibTEL2 + 1);

/* Wrapping of 'amdlibBASELINE' enum */
amdlibBASE12 = int (0);
amdlibBASE23 = int (amdlibBASE12 + 1);
amdlibBASE31 = int (amdlibBASE23 + 1);

/* Wrapping of 'amdlibFRAME_TYPE' enum */
amdlibDARK_FRAME = int (-1);
amdlibTEL1_FRAME = int (amdlibDARK_FRAME + 1);
amdlibTEL2_FRAME = int (amdlibTEL1_FRAME + 1);
amdlibTEL3_FRAME = int (amdlibTEL2_FRAME + 1);
amdlibTEL12_FRAME = int (amdlibTEL3_FRAME + 1);
amdlibTEL23_FRAME = int (amdlibTEL12_FRAME + 1);
amdlibTEL13_FRAME = int (amdlibTEL23_FRAME + 1);
amdlibTEL12Q_FRAME = int (amdlibTEL13_FRAME + 1);
amdlibTEL23Q_FRAME = int (amdlibTEL12Q_FRAME + 1);
amdlibTEL13Q_FRAME = int (amdlibTEL23Q_FRAME + 1);
amdlibTEL123_FRAME = int (amdlibTEL13Q_FRAME + 1);
amdlibSKY_FRAME = int (amdlibTEL123_FRAME + 1);
amdlibUNKNOWN_FRAME = int (amdlibSKY_FRAME + 1);

/* Wrapping of 'amdlibBAND' enum */
amdlibUNKNOWN_BAND = int (-1);
amdlibJ_BAND = int (amdlibUNKNOWN_BAND + 1);
amdlibH_BAND = int (amdlibJ_BAND + 1);
amdlibK_BAND = int (amdlibH_BAND + 1);
amdlibALL_BANDS = int (amdlibK_BAND + 1);

/* Wrapping of 'amdlibSC_TYPE' enum */
amdlibSC_2T = int (1);
amdlibSC_3T = int (amdlibSC_2T + 1);

/* Wrapping of 'amdlibP2VM_TYPE' enum */
amdlibP2VM_2T = int (1);
amdlibP2VM_3T = int (amdlibP2VM_2T + 1);

/* Wrapping of 'amdlibP2VM_ACCURACY' enum */
amdlibP2VM_UNKNOWN_ACC = int (0);
amdlibP2VM_STD_ACC = int (amdlibP2VM_UNKNOWN_ACC + 1);
amdlibP2VM_HIGH_ACC = int (amdlibP2VM_STD_ACC + 1);

/* Wrapping of 'amdlibERROR_TYPE' enum */
amdlibSTATISTICAL_ERROR = int (0);
amdlibTHEORETICAL_ERROR = int (amdlibSTATISTICAL_ERROR + 1);

/* Wrapping of 'amdlibPISTON_ALGORITHM' enum */
amdlibITERATIVE_PHASOR = int (0);
amdlibUNWRAPPED_PHASE = int (amdlibITERATIVE_PHASOR + 1);

/* Wrapping of 'amdlibFRAME_SELECTION' enum */
amdlibNO_FRAME_SEL = int (0);
amdlibFLUX_SEL_PCG = int (amdlibNO_FRAME_SEL + 1);
amdlibFLUX_SEL_THR = int (amdlibFLUX_SEL_PCG + 1);
amdlibFRG_CONTRAST_SEL_PCG = int (amdlibFLUX_SEL_THR + 1);
amdlibFRG_CONTRAST_SEL_THR = int (amdlibFRG_CONTRAST_SEL_PCG + 1);
amdlibOPD_SEL_PCG = int (amdlibFRG_CONTRAST_SEL_THR + 1);
amdlibOPD_SEL_THR = int (amdlibOPD_SEL_PCG + 1);

/* Wrapping of 'amdlibUSER_PREFERENCES' enum */
amdlibBEAUTIFY_PISTON = int (0);
amdlibCHISQUARE_LIMIT = int (amdlibBEAUTIFY_PISTON + 1);
amdlibMAX_PISTON_ERROR = int (amdlibCHISQUARE_LIMIT + 1);
amdlibSHIFT_WLENTABLE = int (amdlibMAX_PISTON_ERROR + 1);
amdlibMIN_PHOTOMETRY = int (amdlibSHIFT_WLENTABLE + 1);
amdlibCORRECT_OPD0 = int (amdlibMIN_PHOTOMETRY + 1);
amdlibLINEARIZE_P2VM_PHASE = int (amdlibCORRECT_OPD0 + 1);
amdlibNORMALIZE_P2VM = int (amdlibLINEARIZE_P2VM_PHASE + 1);
amdlibNO_FUDGE = int (amdlibNORMALIZE_P2VM + 1);
amdlibNO_BIAS = int (amdlibNO_FUDGE + 1);
amdlibDROP = int (amdlibNO_BIAS + 1);
amdlibNORMALIZE_SPECTRUM = int (amdlibDROP + 1);
amdlibBOXCARSMOOTH_P2VM_PHASE = int (amdlibNORMALIZE_SPECTRUM  + 1);
amdlibGAUSSSMOOTH_P2VM_PHASE = int (amdlibBOXCARSMOOTH_P2VM_PHASE + 1);
amdlibAUTO_BADPIXEL = int (amdlibGAUSSSMOOTH_P2VM_PHASE + 1);
amdlibMAX_PISTON_EXCURSION = int (amdlibAUTO_BADPIXEL + 1); 
amdlibGLOBAL_PHOTOMETRY = int (amdlibMAX_PISTON_EXCURSION + 1);
amdlibUSE_GAIN = int (amdlibGLOBAL_PHOTOMETRY + 1);
amdlibZAP_JHK_DISCONTINUTIES = int (amdlibUSE_GAIN + 1);
amdlibAUTO_SHIFT_JHK = int (amdlibZAP_JHK_DISCONTINUTIES + 1);
amdlibFUSSY_COMPUTATION = int (amdlibAUTO_SHIFT_JHK + 1);
amdlibCHANNEL_WIDTH = int (amdlibFUSSY_COMPUTATION + 1);

/****** STRUCTURES ******/

/* Wrapping of 'amdlibKEYWORD' structure */
struct amdlibKEYWORD  
{
    char name(80+1);
    char value(80+1);
    char comment(80+1);
};

/* Wrapping of 'amdlibINS_CFG' structure */
struct amdlibINS_CFG  
{
    int nbKeywords;
    amdlibKEYWORD keywords(1024);
    char history(amdlibMAX_INS_CFG_COMMENTLEN);
    char comment(amdlibMAX_INS_CFG_COMMENTLEN);
};

/* Wrapping of 'amdlibIMAGING_DETECTOR' structure */
struct amdlibIMAGING_DETECTOR  
{
    char origin(80+1);
    char instrument(80+1);
    double dateObsMJD;
    char dateObs(80+1);
    char date(80+1);
    char detDictionaryId(80+1);
    char detId(80+1);
    int nbDetectors;
    int nbRegions;
    int maxCoef;
    int numDim;
    int maxTel;
};

/* Wrapping of 'amdlibIMAGING_DATA' structure */
struct amdlibIMAGING_DATA  
{
    char origin(80+1);
    char instrument(80+1);
    double dateObsMJD;
    char dateObs(80+1);
    char date(80+1);
    char detDictionaryId(80+1);
    char detId(80+1);
    int nbRegions;
    int maxTel;
    int maxIns;
    int maxStep;
};

/* Wrapping of 'amdlibREGION' structure */
struct amdlibREGION  
{
    int regionNumber;
    char regionName(80+1);
    int detectorNumber;
    int ports(3);
    int correlation;
    int corner(2);
    double gain;
    double crVal(2);
    double crPix(2);
    char cType(2,8);
    double cd(2,2);
    double *dmp;
    double *dmc;
    int dimAxis(3);
    double *data;
};

/* Wrapping of 'amdlibCOL_INFO' structure */
struct amdlibCOL_INFO  
{
    int startPixel;
    int nbPixels;
};

/* Wrapping of 'amdlibOI_ARRAY_ELEMENT' structure */
struct amdlibOI_ARRAY_ELEMENT  
{
    char telescopeName(80+1);
    char stationName(80+1);
    int stationIndex;
    double elementDiameter;
    double stationCoordinates(3);
};

/* Wrapping of 'amdlibOI_ARRAY' structure */
struct amdlibOI_ARRAY  
{
    long thisPtr;
    int nbStations;
    char arrayName(80+1);
    char coordinateFrame(80+1);
    double arrayCenterCoordinates(3);
    amdlibOI_ARRAY_ELEMENT *element;
};

/* Wrapping of 'amdlibWAVEDATA' structure */
struct amdlibWAVEDATA  
{
    char origin(80+1);
    char instrument(80+1);
    double dateObsMJD;
    char dateObs(80+1);
    char date(80+1);
    char insDictionaryId(80+1);
    char insId(80+1);
    int nbWlen;
    double wlen(512);
    double bandwidth(512);
    double photoOffset(3);
};

/* Wrapping of 'amdlibBAND_DESC' structure */
struct amdlibBAND_DESC  
{
    char *name;
    double lowerBound;
    double upperBound;
};

/* Wrapping of 'amdlibRAW_DATA' structure */
struct amdlibRAW_DATA  
{
    long thisPtr;
    int p2vmId;
    double time;
    double expTime;
    int nbRows;
    int nbCols;
    int nbFrames;
    amdlibINS_CFG insCfg;
    amdlibWAVEDATA waveData;
    amdlibIMAGING_DETECTOR imagingDetector;
    amdlibIMAGING_DATA imagingData;
    amdlibOI_ARRAY arrayGeometry;
    int nbRegions;
    amdlibREGION *region;
    amdlibREGION *noise;
    double *timeTag;
    int detDataOnly;
    int dataLoaded;
    int dataCalibrated;
    int dataIsSaturated;
    int frameType;
};

/* Wrapping of 'amdlibFLAT_FIELD_MAP' structure */
struct amdlibFLAT_FIELD_MAP  
{
    int mapIsInitialized;
    double data(512,512);
};

/* Wrapping of 'amdlibBAD_PIXEL_MAP' structure */
struct amdlibBAD_PIXEL_MAP  
{
    int mapIsInitialized;
    double data(512,512);
};

/* Wrapping of 'amdlibDARK_DATA' structure */
struct amdlibDARK_DATA  
{
    long thisPtr;
    double expTime;
    int nbRows;
    int nbCols;
    amdlibIMAGING_DETECTOR imagingDetector;
    int nbRegions;
    amdlibREGION *region;
    amdlibREGION *noise;
    double *timeTag;
};

/* Wrapping of 'amdlibISS_INFO' structure */
struct amdlibISS_INFO  
{
    int stationIndex(3);
    double stationCoordinates(3,3);
    double geoLat;
    double lst;
    double ra;
    double dec;
    double projectedBaseStart(3*(3-1)/2);
    double projectedBaseEnd(3*(3-1)/2);
    double projectedAngleStart(3*(3-1)/2);
    double projectedAngleEnd(3*(3-1)/2);
};

/* Wrapping of 'amdlibFRAME_SCIENCE_DATA' structure */
struct amdlibFRAME_SCIENCE_DATA  
{
    double fluxRatio(3);
    double *intf;
    double *sigma2Intf;
    double *photo1;
    double *photo2;
    double *photo3;
    double *photoI;
    double *sigma2Photo1;
    double *sigma2Photo2;
    double *sigma2Photo3;
    double *sigma2PhotoI;
    double snrPhoto1;
    double snrPhoto2;
    double snrPhoto3;
    double integratedPhoto1;
    double integratedPhoto2;
    double integratedPhoto3;
};

/* Wrapping of 'amdlibWAVELENGTH' structure */
struct amdlibWAVELENGTH  
{
    long thisPtr;
    int nbWlen;
    double *wlen;
    double *bandwidth;
};

/* Wrapping of 'amdlibSPECTRUM' structure */
struct amdlibSPECTRUM  
{
    long thisPtr;
    int nbTels;
    int nbWlen;
    double **spec(3);
    double **specErr(3);
    double **specI;
    double **specErrI;
};

/* Wrapping of 'amdlibSCIENCE_DATA' structure */
struct amdlibSCIENCE_DATA  
{
    long thisPtr;
    int p2vmId;
    amdlibINS_CFG insCfg;
    double expTime;
    double *timeTag;
    int nbCols;
    amdlibCOL_INFO col(5-1);
    int nbChannels;
    int *channelNo;
    int nbFrames;
    amdlibISS_INFO issInfo;
     char *badPixels;
     char *badPixelsPt;
    amdlibFRAME_SCIENCE_DATA *frame;
};

/* Wrapping of 'amdlibSC_INPUT_DATA' structure */
struct amdlibSC_INPUT_DATA  
{
    long thisPtr;
    int dataLoaded(6);
    amdlibRAW_DATA rawData(6);
};

/* Wrapping of 'amdlibP2VM_INPUT_DATA' structure */
struct amdlibP2VM_INPUT_DATA  
{
    long thisPtr;
    int p2vmId;
    int nbFrames;
    int dataLoaded(9);
    amdlibSCIENCE_DATA scienceData(9);
};

/* Wrapping of 'amdlibP2VM_MATRIX' structure */
struct amdlibP2VM_MATRIX  
{
    long thisPtr;
    int id;
    amdlibINS_CFG insCfg;
    int type;
    int accuracy;
    int firstChannel;
    int nx;
    int nbChannels;
    int nbFrames;
    double *wlen;
    double *matrix;
    double *matrixPt;
    double *vk;
    double *vkPt;
    double *sumVk;
    double *sumVkPt;
     char *badPixels;
     char *badPixelsPt;
    double *flatField;
    double *flatFieldPt;
    double *photometry;
    double *photometryPt;
     char *flag;
    double *phase;
    double *phasePt;
    double insVis(3*(3-1)/2);
    double insVisErr(3*(3-1)/2);
    double insVisInBand(3*(3-1)/2,3);
    double insVisErrInBand(3*(3-1)/2,3);
};

/* Wrapping of 'amdlibCOMPLEX' structure */
struct amdlibCOMPLEX  
{
    double re;
    double im;
};

/* Wrapping of 'amdlibOI_TARGET_ELEMENT' structure */
struct amdlibOI_TARGET_ELEMENT  
{
    int targetId;
    char targetName(16+1);
    double equinox;
    double raEp0;
    double decEp0;
    double raErr;
    double decErr;
    double sysVel;
    char velTyp(8+1);
    char velDef(8+1);
    double pmRa;
    double pmDec;
    double pmRaErr;
    double pmDecErr;
    double parallax;
    double paraErr;
    char specTyp(16+1);
};

/* Wrapping of 'amdlibOI_TARGET' structure */
struct amdlibOI_TARGET  
{
    long thisPtr;
    int nbTargets;
    amdlibOI_TARGET_ELEMENT *element;
};

/* Wrapping of 'amdlibPHOTOMETRY_TABLE_ENTRY' structure */
struct amdlibPHOTOMETRY_TABLE_ENTRY  
{
    double *fluxSumPiPj;
    double *sigma2FluxSumPiPj;
    double *fluxRatPiPj;
    double *sigma2FluxRatPiPj;
    double *PiMultPj;
};

/* Wrapping of 'amdlibPHOTOMETRY' structure */
struct amdlibPHOTOMETRY  
{
    long thisPtr;
    int nbFrames;
    int nbBases;
    int nbWlen;
    amdlibPHOTOMETRY_TABLE_ENTRY *table;
};

/* Wrapping of 'amdlibVIS_TABLE_ENTRY' structure */
struct amdlibVIS_TABLE_ENTRY  
{
    int targetId;
    double time;
    double dateObsMJD;
    double expTime;
    double uCoord;
    double vCoord;
    int stationIndex(2);
    amdlibCOMPLEX *vis;
    amdlibCOMPLEX *sigma2Vis;
    double *visCovRI;
    double *diffVisAmp;
    double *diffVisAmpErr;
    double *diffVisPhi;
    double *diffVisPhiErr;
    double *chiSquare;
    double frgContrastSnrArray(3);
    int bandFlag(3);
    double frgContrastSnr;
    int *flag;
};

/* Wrapping of 'amdlibVIS' structure */
struct amdlibVIS  
{
    long thisPtr;
    int nbFrames;
    int nbBases;
    int nbWlen;
    char dateObs(80+1);
    amdlibVIS_TABLE_ENTRY *table;
};

/* Wrapping of 'amdlibVIS2_TABLE_ENTRY' structure */
struct amdlibVIS2_TABLE_ENTRY  
{
    int targetId;
    double time;
    double dateObsMJD;
    double expTime;
    double *vis2;
    double *vis2Error;
    double uCoord;
    double vCoord;
    int stationIndex(2);
    int *flag;
};

/* Wrapping of 'amdlibVIS2' structure */
struct amdlibVIS2  
{
    long thisPtr;
    int nbFrames;
    int nbBases;
    int nbWlen;
    double vis12;
    double vis23;
    double vis31;
    double sigmaVis12;
    double sigmaVis23;
    double sigmaVis31;
    char dateObs(80+1);
    amdlibVIS2_TABLE_ENTRY *table;
};

/* Wrapping of 'amdlibVIS3_TABLE_ENTRY' structure */
struct amdlibVIS3_TABLE_ENTRY  
{
    int targetId;
    double time;
    double dateObsMJD;
    double expTime;
    double *vis3Amplitude;
    double *vis3AmplitudeError;
    double *vis3Phi;
    double *vis3PhiError;
    double u1Coord;
    double v1Coord;
    double u2Coord;
    double v2Coord;
    int stationIndex(3);
    int *flag;
};

/* Wrapping of 'amdlibVIS3' structure */
struct amdlibVIS3  
{
    long thisPtr;
    int nbFrames;
    int nbClosures;
    int nbWlen;
    double averageClosure;
    double averageClosureError;
    char dateObs(80+1);
    amdlibVIS3_TABLE_ENTRY *table;
};

/* Wrapping of 'amdlibPISTON' structure */
struct amdlibPISTON  
{
    long thisPtr;
    int nbFrames;
    int nbBases;
    int bandFlag(3);
    double **pistonOPDArray(3);
    double **sigmaPistonArray(3);
    double *pistonOPD;
    double *sigmaPiston;
};

/* Wrapping of 'amdlibSELECTION_BAND' structure */
struct amdlibSELECTION_BAND  
{
    int nbSelectedFrames(3*(3-1)/2);
    int firstSelectedFrame(3*(3-1)/2);
     char *isSelectedPt;
     char *isSelected;
    int nbFramesOkForClosure;
    int *frameOkForClosure;
};

/* Wrapping of 'amdlibSELECTION' structure */
struct amdlibSELECTION  
{
    int nbFrames;
    int nbBases;
    amdlibSELECTION_BAND band(3);
};

/* Wrapping of 'amdlibCPT_VIS_OPTIONS' structure */
struct amdlibCPT_VIS_OPTIONS  
{
    int binSize;
    int errorType;
    int pistonType;
    int noCheckP2vmId;
    int frameSelectionType;
    double frameSelectionRatio;
};

/****** FUNCTIONS ******/

/* 
 * Wrapping of 'amdlibGetVersion' function */   
  
extern __amdlibGetVersion;
/* PROTOTYPE
    void  amdlibGetVersion( pointer )
*/
/* DOCUMENT  amdlibGetVersion( pointer )
  * C-prototype:
    ------------
    void amdlibGetVersion  (char version)
*/

/* 
 * Wrapping of 'amdlibPrintVersion' function */   
  
extern __amdlibPrintVersion;
/* PROTOTYPE
    void  amdlibPrintVersion( void )
*/
/* DOCUMENT  amdlibPrintVersion( void )
  * C-prototype:
    ------------
    void amdlibPrintVersion  (void )
*/

/* 
 * Wrapping of 'amdlibLoadRawData' function */   
  
extern __amdlibLoadRawData;
/* PROTOTYPE
    int  amdlibLoadRawData( string , pointer , pointer )
*/
/* DOCUMENT  amdlibLoadRawData( string , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadRawData  (const char *filename ,amdlibRAW_DATA *rawData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibLoadRawDataHdr' function */   
  
extern __amdlibLoadRawDataHdr;
/* PROTOTYPE
    int  amdlibLoadRawDataHdr( string , pointer , pointer )
*/
/* DOCUMENT  amdlibLoadRawDataHdr( string , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadRawDataHdr  (const char *filename ,amdlibRAW_DATA *rawData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibLoadRawFrames' function */   
  
extern __amdlibLoadRawFrames;
/* PROTOTYPE
    int  amdlibLoadRawFrames( string , pointer , int , int , pointer )
*/
/* DOCUMENT  amdlibLoadRawFrames( string , pointer , int , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadRawFrames  (const char *filename ,amdlibRAW_DATA *rawData ,int firstFrame ,int nbFrames ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseRawData' function */   
  
extern __amdlibReleaseRawData;
/* PROTOTYPE
    void  amdlibReleaseRawData( pointer )
*/
/* DOCUMENT  amdlibReleaseRawData( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseRawData  (amdlibRAW_DATA *rawData)
*/

/* 
 * Wrapping of 'amdlibGluedImage2RawData' function */   
  
extern __amdlibGluedImage2RawData;
/* PROTOTYPE
    int  amdlibGluedImage2RawData( pointer , int , int , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGluedImage2RawData( pointer , int , int , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGluedImage2RawData  (double *gluedImage ,int nbRows ,int nbCols ,int colWidth ,int rowHeight ,amdlibRAW_DATA *rawData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibExtractColPos' function */   
  
extern __amdlibExtractColPos;
/* PROTOTYPE
    int  amdlibExtractColPos( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibExtractColPos( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibExtractColPos  (amdlibRAW_DATA *rawData ,double colPos ,double maxVal)
*/

/* 
 * Wrapping of 'amdlibExtractSpectPos' function */   
  
extern __amdlibExtractSpectPos;
/* PROTOTYPE
    int  amdlibExtractSpectPos( pointer , pointer )
*/
/* DOCUMENT  amdlibExtractSpectPos( pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibExtractSpectPos  (amdlibRAW_DATA *rawData ,double spectPos)
*/

/* 
 * Wrapping of 'amdlibIsSameDetCfg' function */   
  
extern __amdlibIsSameDetCfg;
/* PROTOTYPE
    int  amdlibIsSameDetCfg( pointer , pointer )
*/
/* DOCUMENT  amdlibIsSameDetCfg( pointer , pointer )
  * C-prototype:
    ------------
    amdlibBOOLEAN amdlibIsSameDetCfg  (amdlibRAW_DATA *rawData1 ,amdlibRAW_DATA *rawData2)
*/

/* 
 * Wrapping of 'amdlibLoadBadPixelMap' function */   
  
extern __amdlibLoadBadPixelMap;
/* PROTOTYPE
    int  amdlibLoadBadPixelMap( string , pointer )
*/
/* DOCUMENT  amdlibLoadBadPixelMap( string , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadBadPixelMap  (const char *filename ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibSetBadPixelMap' function */   
  
extern __amdlibSetBadPixelMap;
/* PROTOTYPE
    int  amdlibSetBadPixelMap( int )
*/
/* DOCUMENT  amdlibSetBadPixelMap( int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibSetBadPixelMap  (amdlibBOOLEAN goodPixel)
*/

/* 
 * Wrapping of 'amdlibLoadFlatFieldMap' function */   
  
extern __amdlibLoadFlatFieldMap;
/* PROTOTYPE
    int  amdlibLoadFlatFieldMap( string , pointer )
*/
/* DOCUMENT  amdlibLoadFlatFieldMap( string , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadFlatFieldMap  (const char *filename ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibSetFlatFieldMap' function */   
  
extern __amdlibSetFlatFieldMap;
/* PROTOTYPE
    int  amdlibSetFlatFieldMap( double )
*/
/* DOCUMENT  amdlibSetFlatFieldMap( double )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibSetFlatFieldMap  (double value)
*/

/* 
 * Wrapping of 'amdlibReleaseDarkData' function */   
  
extern __amdlibReleaseDarkData;
/* PROTOTYPE
    void  amdlibReleaseDarkData( pointer )
*/
/* DOCUMENT  amdlibReleaseDarkData( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseDarkData  (amdlibDARK_DATA *dark)
*/

/* 
 * Wrapping of 'amdlibGenerateDarkData' function */   
  
extern __amdlibGenerateDarkData;
/* PROTOTYPE
    int  amdlibGenerateDarkData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGenerateDarkData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGenerateDarkData  (amdlibRAW_DATA *rawData ,amdlibDARK_DATA *dark ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibSetDarkData' function */   
  
extern __amdlibSetDarkData;
/* PROTOTYPE
    int  amdlibSetDarkData( pointer , pointer , double , pointer )
*/
/* DOCUMENT  amdlibSetDarkData( pointer , pointer , double , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibSetDarkData  (amdlibRAW_DATA *rawData ,amdlibDARK_DATA *dark ,double value ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCalibrateRawData' function */   
  
extern __amdlibCalibrateRawData;
/* PROTOTYPE
    int  amdlibCalibrateRawData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCalibrateRawData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCalibrateRawData  (amdlibDARK_DATA *dark ,amdlibRAW_DATA *rawData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibPerformSpectralCalibration' function */   
  
extern __amdlibPerformSpectralCalibration;
/* PROTOTYPE
    int  amdlibPerformSpectralCalibration( pointer , int , pointer , pointer )
*/
/* DOCUMENT  amdlibPerformSpectralCalibration( pointer , int , pointer, pointer  , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibPerformSpectralCalibration  (amdlibSC_INPUT_DATA *scData ,amdlibSC_TYPE scType ,amdlibWAVEDATA *calWaveData ,amdlibDOUBLE *displacement, amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibRawData2ScienceData' function */   
  
extern __amdlibRawData2ScienceData;
/* PROTOTYPE
    int  amdlibRawData2ScienceData( pointer , pointer , pointer , int , pointer )
*/
/* DOCUMENT  amdlibRawData2ScienceData( pointer , pointer , pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibRawData2ScienceData  (amdlibRAW_DATA *rawData ,amdlibWAVEDATA *waveData ,amdlibSCIENCE_DATA *scienceData ,amdlibBOOLEAN sumData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseScienceData' function */   
  
extern __amdlibReleaseScienceData;
/* PROTOTYPE
    void  amdlibReleaseScienceData( pointer )
*/
/* DOCUMENT  amdlibReleaseScienceData( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseScienceData  (amdlibSCIENCE_DATA *scienceData)
*/

/* 
 * Wrapping of 'amdlibAddToSpectralCalibrationData' function */   
  
extern __amdlibAddToSpectralCalibrationData;
/* PROTOTYPE
    int  amdlibAddToSpectralCalibrationData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibAddToSpectralCalibrationData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAddToSpectralCalibrationData  (amdlibRAW_DATA *rawData ,amdlibSC_INPUT_DATA *spectralCalibrationData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibAddP2VDataToSpectralCalibrationData' function */   
  
extern __amdlibAddP2VDataToSpectralCalibrationData;
/* PROTOTYPE
    int  amdlibAddP2VDataToSpectralCalibrationData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibAddP2VDataToSpectralCalibrationData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAddP2VDataToSpectralCalibrationData  (amdlibRAW_DATA *rawData ,amdlibSC_INPUT_DATA *spectralCalibrationData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseSpectralCalibrationData' function */   
  
extern __amdlibReleaseSpectralCalibrationData;
/* PROTOTYPE
    void  amdlibReleaseSpectralCalibrationData( pointer )
*/
/* DOCUMENT  amdlibReleaseSpectralCalibrationData( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseSpectralCalibrationData  (amdlibSC_INPUT_DATA *spectralCalibrationData)
*/

/* 
 * Wrapping of 'amdlibGetBand' function */   
  
extern __amdlibGetBand;
/* PROTOTYPE
    int  amdlibGetBand( double )
*/
/* DOCUMENT  amdlibGetBand( double )
  * C-prototype:
    ------------
    amdlibBAND amdlibGetBand  (double wavelength)
*/

/* 
 * Wrapping of 'amdlibBandNumToStr' function */   
  
extern __amdlibBandNumToStr;
/* PROTOTYPE
    char  amdlibBandNumToStr( int )
*/
/* DOCUMENT  amdlibBandNumToStr( int )
  * C-prototype:
    ------------
    char amdlibBandNumToStr  (amdlibBAND band)
*/

/* 
 * Wrapping of 'amdlibGetWaveDataFromRawData' function */   
  
extern __amdlibGetWaveDataFromRawData;
/* PROTOTYPE
    int  amdlibGetWaveDataFromRawData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGetWaveDataFromRawData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetWaveDataFromRawData  (amdlibRAW_DATA *rawData ,amdlibWAVEDATA *waveData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibGetWaveDataFromP2vm' function */   
  
extern __amdlibGetWaveDataFromP2vm;
/* PROTOTYPE
    int  amdlibGetWaveDataFromP2vm( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGetWaveDataFromP2vm( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetWaveDataFromP2vm  (amdlibP2VM_MATRIX *p2vm ,amdlibWAVEDATA *waveData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibGetChannelsInBand' function */   
  
extern __amdlibGetChannelsInBand;
/* PROTOTYPE
    int  amdlibGetChannelsInBand( pointer , pointer , pointer , int , pointer , pointer )
*/
/* DOCUMENT  amdlibGetChannelsInBand( pointer , pointer , pointer , int , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetChannelsInBand  (amdlibP2VM_MATRIX *p2vm ,amdlibSCIENCE_DATA *data ,amdlibWAVEDATA *waveData ,amdlibBAND band ,int *nbChannelsInBand ,int *channelNoInBand)
*/

/* 
 * Wrapping of 'amdlibAllocateSpectrum' function */   
  
extern __amdlibAllocateSpectrum;
/* PROTOTYPE
    int  amdlibAllocateSpectrum( pointer , int , int )
*/
/* DOCUMENT  amdlibAllocateSpectrum( pointer , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateSpectrum  (amdlibSPECTRUM *spc ,const int nbTels ,const int nbWlen)
*/

/* 
 * Wrapping of 'amdlibReleaseSpectrum' function */   
  
extern __amdlibReleaseSpectrum;
/* PROTOTYPE
    void  amdlibReleaseSpectrum( pointer )
*/
/* DOCUMENT  amdlibReleaseSpectrum( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseSpectrum  (amdlibSPECTRUM *spc)
*/

/* 
 * Wrapping of 'amdlibGetSpectrumFromP2VM' function */   
  
extern __amdlibGetSpectrumFromP2VM;
/* PROTOTYPE
    int  amdlibGetSpectrumFromP2VM( pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGetSpectrumFromP2VM( pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetSpectrumFromP2VM  (amdlibP2VM_MATRIX *p2vm ,amdlibWAVELENGTH *wave ,amdlibSPECTRUM *spectrum ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibGetSpectrumFromScienceData' function */   
  
extern __amdlibGetSpectrumFromScienceData;
/* PROTOTYPE
    int  amdlibGetSpectrumFromScienceData( pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGetSpectrumFromScienceData( pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetSpectrumFromScienceData  (amdlibSCIENCE_DATA *data ,amdlibWAVEDATA *waveData ,amdlibWAVELENGTH *wave ,amdlibSPECTRUM *spectrum ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibAddToP2vmData' function */   
  
extern __amdlibAddToP2vmData;
/* PROTOTYPE
    int  amdlibAddToP2vmData( pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibAddToP2vmData( pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAddToP2vmData  (amdlibRAW_DATA *rawData ,amdlibWAVEDATA *waveData ,amdlibP2VM_INPUT_DATA *p2vmData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseP2vmData' function */   
  
extern __amdlibReleaseP2vmData;
/* PROTOTYPE
    void  amdlibReleaseP2vmData( pointer )
*/
/* DOCUMENT  amdlibReleaseP2vmData( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseP2vmData  (amdlibP2VM_INPUT_DATA *p2vmData)
*/

/* 
 * Wrapping of 'amdlibComputeP2VM' function */   
  
extern __amdlibComputeP2VM;
/* PROTOTYPE
    int  amdlibComputeP2VM( pointer , int , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibComputeP2VM( pointer , int , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibComputeP2VM  (amdlibP2VM_INPUT_DATA *p2vmData ,amdlibP2VM_TYPE p2vmType ,amdlibWAVEDATA *waveData ,amdlibP2VM_MATRIX *p2vm ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseP2VM' function */   
  
extern __amdlibReleaseP2VM;
/* PROTOTYPE
    void  amdlibReleaseP2VM( pointer )
*/
/* DOCUMENT  amdlibReleaseP2VM( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseP2VM  (amdlibP2VM_MATRIX *p2vm)
*/

/* 
 * Wrapping of 'amdlibIsValidChannel' function */   
  
extern __amdlibIsValidChannel;
/* PROTOTYPE
    int  amdlibIsValidChannel( pointer , int , pointer )
*/
/* DOCUMENT  amdlibIsValidChannel( pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibBOOLEAN amdlibIsValidChannel  (amdlibP2VM_MATRIX *p2vm ,int channelNo ,int *iChannel)
*/

/* 
 * Wrapping of 'amdlibIsP2VMUsable' function */   
  
extern __amdlibIsP2VMUsable;
/* PROTOTYPE
    int  amdlibIsP2VMUsable( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibIsP2VMUsable( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibBOOLEAN amdlibIsP2VMUsable  (amdlibSCIENCE_DATA *scienceData ,amdlibP2VM_MATRIX *p2vm ,double *percentage)
*/

/* 
 * Wrapping of 'amdlibSaveP2VM' function */   
  
extern __amdlibSaveP2VM;
/* PROTOTYPE
    int  amdlibSaveP2VM( string , pointer , int , pointer )
*/
/* DOCUMENT  amdlibSaveP2VM( string , pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibSaveP2VM  (const char *filename ,amdlibP2VM_MATRIX *p2vm ,amdlibP2VM_ACCURACY accuracy ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibLoadP2VM' function */   
  
extern __amdlibLoadP2VM;
/* PROTOTYPE
    int  amdlibLoadP2VM( string , pointer , pointer )
*/
/* DOCUMENT  amdlibLoadP2VM( string , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadP2VM  (const char *filename ,amdlibP2VM_MATRIX *p2vm ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibDuplicateP2VM' function */   
  
extern __amdlibDuplicateP2VM;
/* PROTOTYPE
    int  amdlibDuplicateP2VM( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibDuplicateP2VM( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibDuplicateP2VM  (amdlibP2VM_MATRIX *srcP2vm ,amdlibP2VM_MATRIX *dstP2vm ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibMergeP2VM' function */   
  
extern __amdlibMergeP2VM;
/* PROTOTYPE
    int  amdlibMergeP2VM( pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibMergeP2VM( pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibMergeP2VM  (amdlibP2VM_MATRIX *firstP2vm ,amdlibP2VM_MATRIX *secondP2vm ,amdlibP2VM_MATRIX *mergedP2vm ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyP2VM' function */   
  
extern __amdlibCopyP2VM;
/* PROTOTYPE
    int  amdlibCopyP2VM( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyP2VM( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyP2VM  (amdlibP2VM_MATRIX *srcP2vm ,amdlibP2VM_MATRIX *dstP2vm ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReadSelectionFile' function */   
  
extern __amdlibReadSelectionFile;
/* PROTOTYPE
    int  amdlibReadSelectionFile( string , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibReadSelectionFile( string , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibReadSelectionFile  (const char *fileName ,amdlibINS_CFG *selKeywList ,amdlibSELECTION *selectionBand ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibWriteSelectionFile' function */   
  
extern __amdlibWriteSelectionFile;
/* PROTOTYPE
    int  amdlibWriteSelectionFile( string , pointer , pointer )
*/
/* DOCUMENT  amdlibWriteSelectionFile( string , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibWriteSelectionFile  (const char *fileName ,amdlibSELECTION *selection ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseSelection' function */   
  
extern __amdlibReleaseSelection;
/* PROTOTYPE
    void  amdlibReleaseSelection( pointer )
*/
/* DOCUMENT  amdlibReleaseSelection( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseSelection  (amdlibSELECTION *selection)
*/

/* 
 * Wrapping of 'amdlibComputeVisibilities' function */   
  
extern __amdlibComputeVisibilities;
/* PROTOTYPE
    int  amdlibComputeVisibilities( pointer , pointer , pointer , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibComputeVisibilities( pointer , pointer , pointer , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    int amdlibComputeVisibilities  (amdlibSCIENCE_DATA *data ,amdlibP2VM_MATRIX *p2vm ,amdlibWAVEDATA *waveData ,amdlibBAND band ,amdlibCPT_VIS_OPTIONS *visOptions ,amdlibPHOTOMETRY *photometry ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibWAVELENGTH *wave ,amdlibPISTON *opd ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibExtractVisibilities' function */   
  
extern __amdlibExtractVisibilities;
/* PROTOTYPE
    int  amdlibExtractVisibilities( pointer , pointer , pointer , int , int , int , int , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibExtractVisibilities( pointer , pointer , pointer , int , int , int , int , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    int amdlibExtractVisibilities  (amdlibSCIENCE_DATA *data ,amdlibP2VM_MATRIX *p2vm ,amdlibWAVEDATA *waveData ,amdlibBAND band ,int nbBinning ,amdlibERROR_TYPE errorType ,amdlibPISTON_ALGORITHM pistonType ,amdlibBOOLEAN noCheckP2vmId ,amdlibPHOTOMETRY *photometry ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibWAVELENGTH *wave ,amdlibPISTON *opd ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibComputeVisibilitiesFor' function */   
  
extern __amdlibComputeVisibilitiesFor;
/* PROTOTYPE
    int  amdlibComputeVisibilitiesFor( pointer , pointer , pointer , pointer , int , int , int , int , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibComputeVisibilitiesFor( pointer , pointer , pointer , pointer , int , int , int , int , int , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibComputeVisibilitiesFor  (amdlibSCIENCE_DATA *data ,amdlibP2VM_MATRIX *p2vm ,amdlibWAVEDATA *waveData ,int *channelNo ,int nbChannels ,int nbBinning ,amdlibERROR_TYPE errorType ,amdlibPISTON_ALGORITHM pistonType ,amdlibBOOLEAN noCheckP2vmId ,amdlibPHOTOMETRY *photometry ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibWAVELENGTH *wave ,amdlibPISTON *opd ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibAverageVisibilities' function */   
  
extern __amdlibAverageVisibilities;
/* PROTOTYPE
    int  amdlibAverageVisibilities( pointer , pointer , pointer , pointer , pointer , int , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibAverageVisibilities( pointer , pointer , pointer , pointer , pointer , int , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAverageVisibilities  (amdlibPHOTOMETRY *phot ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibPISTON *opd ,amdlibBAND band ,amdlibWAVELENGTH *wave ,amdlibSELECTION *selectedFrames ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibAllocatePhotometry' function */   
  
extern __amdlibAllocatePhotometry;
/* PROTOTYPE
    int  amdlibAllocatePhotometry( pointer , int , int , int )
*/
/* DOCUMENT  amdlibAllocatePhotometry( pointer , int , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocatePhotometry  (amdlibPHOTOMETRY *photometry ,const int nbFrames ,const int nbBases ,const int nbWlen)
*/

/* 
 * Wrapping of 'amdlibReleasePhotometry' function */   
  
extern __amdlibReleasePhotometry;
/* PROTOTYPE
    void  amdlibReleasePhotometry( pointer )
*/
/* DOCUMENT  amdlibReleasePhotometry( pointer )
  * C-prototype:
    ------------
    void amdlibReleasePhotometry  (amdlibPHOTOMETRY *photometry)
*/

/* 
 * Wrapping of 'amdlibAllocateVis' function */   
  
extern __amdlibAllocateVis;
/* PROTOTYPE
    int  amdlibAllocateVis( pointer , int , int , int )
*/
/* DOCUMENT  amdlibAllocateVis( pointer , int , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateVis  (amdlibVIS *vis ,const int nbFrames ,const int nbBases ,const int nbWlen)
*/

/* 
 * Wrapping of 'amdlibReleaseVis' function */   
  
extern __amdlibReleaseVis;
/* PROTOTYPE
    void  amdlibReleaseVis( pointer )
*/
/* DOCUMENT  amdlibReleaseVis( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseVis  (amdlibVIS *vis)
*/

/* 
 * Wrapping of 'amdlibAllocateVis2' function */   
  
extern __amdlibAllocateVis2;
/* PROTOTYPE
    int  amdlibAllocateVis2( pointer , int , int , int )
*/
/* DOCUMENT  amdlibAllocateVis2( pointer , int , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateVis2  (amdlibVIS2 *vis2 ,const int nbFrames ,const int nbBases ,const int nbWlen)
*/

/* 
 * Wrapping of 'amdlibReleaseVis2' function */   
  
extern __amdlibReleaseVis2;
/* PROTOTYPE
    void  amdlibReleaseVis2( pointer )
*/
/* DOCUMENT  amdlibReleaseVis2( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseVis2  (amdlibVIS2 *vis2)
*/

/* 
 * Wrapping of 'amdlibAllocateVis3' function */   
  
extern __amdlibAllocateVis3;
/* PROTOTYPE
    int  amdlibAllocateVis3( pointer , int , int , int )
*/
/* DOCUMENT  amdlibAllocateVis3( pointer , int , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateVis3  (amdlibVIS3 *vis3 ,const int nbFrames ,const int nbClosures ,const int nbWlen)
*/

/* 
 * Wrapping of 'amdlibReleaseVis3' function */   
  
extern __amdlibReleaseVis3;
/* PROTOTYPE
    void  amdlibReleaseVis3( pointer )
*/
/* DOCUMENT  amdlibReleaseVis3( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseVis3  (amdlibVIS3 *vis3)
*/

/* 
 * Wrapping of 'amdlibAllocateWavelength' function */   
  
extern __amdlibAllocateWavelength;
/* PROTOTYPE
    int  amdlibAllocateWavelength( pointer , int , pointer )
*/
/* DOCUMENT  amdlibAllocateWavelength( pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateWavelength  (amdlibWAVELENGTH *wave ,const int nbWlen ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseWavelength' function */   
  
extern __amdlibReleaseWavelength;
/* PROTOTYPE
    void  amdlibReleaseWavelength( pointer )
*/
/* DOCUMENT  amdlibReleaseWavelength( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseWavelength  (amdlibWAVELENGTH *wave)
*/

/* 
 * Wrapping of 'amdlibAllocatePiston' function */   
  
extern __amdlibAllocatePiston;
/* PROTOTYPE
    int  amdlibAllocatePiston( pointer , int , int )
*/
/* DOCUMENT  amdlibAllocatePiston( pointer , int , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocatePiston  (amdlibPISTON *piston ,const int nbFrames ,const int nbBases)
*/

/* 
 * Wrapping of 'amdlibReleasePiston' function */   
  
extern __amdlibReleasePiston;
/* PROTOTYPE
    void  amdlibReleasePiston( pointer )
*/
/* DOCUMENT  amdlibReleasePiston( pointer )
  * C-prototype:
    ------------
    void amdlibReleasePiston  (amdlibPISTON *opd)
*/

/* 
 * Wrapping of 'amdlibAllocateOiTarget' function */   
  
extern __amdlibAllocateOiTarget;
/* PROTOTYPE
    int  amdlibAllocateOiTarget( pointer , int )
*/
/* DOCUMENT  amdlibAllocateOiTarget( pointer , int )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateOiTarget  (amdlibOI_TARGET *target ,const int nbElements)
*/

/* 
 * Wrapping of 'amdlibReleaseOiArray' function */   
  
extern __amdlibReleaseOiArray;
/* PROTOTYPE
    void  amdlibReleaseOiArray( pointer )
*/
/* DOCUMENT  amdlibReleaseOiArray( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseOiArray  (amdlibOI_ARRAY *array)
*/

/* 
 * Wrapping of 'amdlibAllocateOiArray' function */   
  
extern __amdlibAllocateOiArray;
/* PROTOTYPE
    int  amdlibAllocateOiArray( pointer , int , pointer )
*/
/* DOCUMENT  amdlibAllocateOiArray( pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibAllocateOiArray  (amdlibOI_ARRAY *array ,const int nbElements ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibReleaseOiTarget' function */   
  
extern __amdlibReleaseOiTarget;
/* PROTOTYPE
    void  amdlibReleaseOiTarget( pointer )
*/
/* DOCUMENT  amdlibReleaseOiTarget( pointer )
  * C-prototype:
    ------------
    void amdlibReleaseOiTarget  (amdlibOI_TARGET *target)
*/

/* 
 * Wrapping of 'amdlibSaveOiFile' function */   
  
extern __amdlibSaveOiFile;
/* PROTOTYPE
    int  amdlibSaveOiFile( string , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibSaveOiFile( string , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibSaveOiFile  (const char *filename ,amdlibINS_CFG *insCfg ,amdlibOI_ARRAY *array ,amdlibOI_TARGET *target ,amdlibPHOTOMETRY *photometry ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibWAVELENGTH *wave ,amdlibPISTON *pst ,amdlibSPECTRUM *spectrum ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibLoadOiFile' function */   
  
extern __amdlibLoadOiFile;
/* PROTOTYPE
    int  amdlibLoadOiFile( string , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibLoadOiFile( string , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibLoadOiFile  (const char *filename ,amdlibINS_CFG *insCfg ,amdlibOI_ARRAY *array ,amdlibOI_TARGET *target ,amdlibPHOTOMETRY *photometry ,amdlibVIS *vis ,amdlibVIS2 *vis2 ,amdlibVIS3 *vis3 ,amdlibWAVELENGTH *wave ,amdlibPISTON *pst ,amdlibSPECTRUM *spectrum ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibGetOiArrayFromRawData' function */   
  
extern __amdlibGetOiArrayFromRawData;
/* PROTOTYPE
    int  amdlibGetOiArrayFromRawData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibGetOiArrayFromRawData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetOiArrayFromRawData  (amdlibRAW_DATA *rawData ,amdlibOI_ARRAY *array ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibGetOiTargetFromRawData' function */   
  
extern __amdlibGetOiTargetFromRawData;
/* PROTOTYPE
    int  amdlibGetOiTargetFromRawData( pointer , pointer )
*/
/* DOCUMENT  amdlibGetOiTargetFromRawData( pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibGetOiTargetFromRawData  (amdlibRAW_DATA *data ,amdlibOI_TARGET *target)
*/

/* 
 * Wrapping of 'amdlibCopyRegionInfo' function */   
  
extern __amdlibCopyRegionInfo;
/* PROTOTYPE
    int  amdlibCopyRegionInfo( pointer , pointer , int , pointer )
*/
/* DOCUMENT  amdlibCopyRegionInfo( pointer , pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyRegionInfo  (amdlibREGION *srcRegions ,amdlibREGION *dstRegions ,int nbRegions ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyRegionData' function */   
  
extern __amdlibCopyRegionData;
/* PROTOTYPE
    int  amdlibCopyRegionData( pointer , pointer , int , pointer )
*/
/* DOCUMENT  amdlibCopyRegionData( pointer , pointer , int , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyRegionData  (amdlibREGION *srcRegions ,amdlibREGION *dstRegions ,int nbRegions ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyScienceData' function */   
  
extern __amdlibCopyScienceData;
/* PROTOTYPE
    int  amdlibCopyScienceData( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyScienceData( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyScienceData  (amdlibSCIENCE_DATA *srcScienceData ,amdlibSCIENCE_DATA *dstScienceData ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopySelection' function */   
  
extern __amdlibCopySelection;
/* PROTOTYPE
    int  amdlibCopySelection( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopySelection( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopySelection  (amdlibSELECTION *srcSelection ,amdlibSELECTION *dstSelection ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyOiArray' function */   
  
extern __amdlibCopyOiArray;
/* PROTOTYPE
    int  amdlibCopyOiArray( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyOiArray( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyOiArray  (amdlibOI_ARRAY *srcOiArray ,amdlibOI_ARRAY *dstOiArray ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyOiTarget' function */   
  
extern __amdlibCopyOiTarget;
/* PROTOTYPE
    int  amdlibCopyOiTarget( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyOiTarget( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyOiTarget  (amdlibOI_TARGET *srcOiTarget ,amdlibOI_TARGET *dstOiTarget ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyPhotometry' function */   
  
extern __amdlibCopyPhotometry;
/* PROTOTYPE
    int  amdlibCopyPhotometry( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyPhotometry( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyPhotometry  (amdlibPHOTOMETRY *srcPhotometry ,amdlibPHOTOMETRY *dstPhotometry ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyVis' function */   
  
extern __amdlibCopyVis;
/* PROTOTYPE
    int  amdlibCopyVis( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyVis( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyVis  (amdlibVIS *srcVis ,amdlibVIS *dstVis ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyVis2' function */   
  
extern __amdlibCopyVis2;
/* PROTOTYPE
    int  amdlibCopyVis2( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyVis2( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyVis2  (amdlibVIS2 *srcVis2 ,amdlibVIS2 *dstVis2 ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyVis3' function */   
  
extern __amdlibCopyVis3;
/* PROTOTYPE
    int  amdlibCopyVis3( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyVis3( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyVis3  (amdlibVIS3 *srcVis3 ,amdlibVIS3 *dstVis3 ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyWavelength' function */   
  
extern __amdlibCopyWavelength;
/* PROTOTYPE
    int  amdlibCopyWavelength( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyWavelength( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyWavelength  (amdlibWAVELENGTH *srcWlen ,amdlibWAVELENGTH *dstWlen ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyPiston' function */   
  
extern __amdlibCopyPiston;
/* PROTOTYPE
    int  amdlibCopyPiston( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopyPiston( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyPiston  (amdlibPISTON *srcOpd ,amdlibPISTON *dstOpd ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopySpectrum' function */   
  
extern __amdlibCopySpectrum;
/* PROTOTYPE
    int  amdlibCopySpectrum( pointer , pointer , pointer )
*/
/* DOCUMENT  amdlibCopySpectrum( pointer , pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopySpectrum  (amdlibSPECTRUM *srcSpectrum ,amdlibSPECTRUM *dstSpectrum ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyBadPixelMap' function */   
  
extern __amdlibCopyBadPixelMap;
/* PROTOTYPE
    int  amdlibCopyBadPixelMap( pointer , pointer )
*/
/* DOCUMENT  amdlibCopyBadPixelMap( pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyBadPixelMap  (amdlibBAD_PIXEL_MAP *dstBadPixel ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of 'amdlibCopyFlatFieldMap' function */   
  
extern __amdlibCopyFlatFieldMap;
/* PROTOTYPE
    int  amdlibCopyFlatFieldMap( pointer , pointer )
*/
/* DOCUMENT  amdlibCopyFlatFieldMap( pointer , pointer )
  * C-prototype:
    ------------
    amdlibCOMPL_STAT amdlibCopyFlatFieldMap  (amdlibFLAT_FIELD_MAP *dstFlatField ,amdlibERROR_MSG errMsg)
*/

/* 
 * Wrapping of ' amdlibSetUserPref' function */   

extern __amdlibSetUserPref;
/* PROTOTYPE
    void amdlibSetUserPref( int , double )
*/
/* DOCUMENT amdlibSetUserPref( int , double ) 
  * C-prototype:
    ------------
    void amdlibSetUserPref(int code, amdlibDOUBLE value);
*/
/* 
 * Wrapping of ' amdlibSetUserPref' function */   

extern __amdlibUnsetUserPref;
/* PROTOTYPE
    void amdlibUnsetUserPref( int )
*/
/* DOCUMENT amdlibUnsetUserPref( int ) 
  * C-prototype:
    ------------
    void amdlibUnsetUserPref(int code );
*/
